###################################
# DelayedDeaths v1.0 by JoeyT2008 #
###################################

###CONFIGURATION###
delay = 0.05
###################

import es, playerlib, gamethread

players = {}
delay = es.ServerVar("dd_delay", str(delay), "How long after death will the player die.")
es.ServerVar("dd_version", "1.0", "Version of DelayedDeaths that is running on this server.").makepublic()
properties = ["attacker", "weapon", "headshot", "userid", "dmg_health", "hitgroup"]

def load():
    es.server.cmd('est_RegEventBlock player_hurt "es_xdoblock delayeddeath/player_hurt_hooked"')
    es.server.cmd('est_RegEventBlock player_death "es_xdoblock delayeddeath/player_death_hooked"')

def unload():
    es.server.cmd('est_UnRegEventBlock player_hurt "es_xdoblock delayeddeath/player_hurt_hooked"')
    es.server.cmd('est_UnRegEventBlock player_death "es_xdoblock delayeddeath/player_death_hooked"')

def player_hurt_hooked():
    for property in properties:
        es.ServerVar("dd_%s" % property, 0)
        try: es.server.cmd("est_geteventinfo dd_%s %s" % (property, property))
        except: pass
    userid = str(es.ServerVar("dd_userid"))
    if playerlib.getPlayer(userid).get("health") <= 0:
        damage = int(playerlib.getPlayer(userid).get("health")) + int(es.ServerVar("dd_dmg_health"))
        headshot = int(es.ServerVar("dd_hitgroup"))
        if not headshot == 1: headshot = 0
        health = playerlib.getPlayer(userid).get("health")
        playerlib.getPlayer(userid).set("health", damage)
        players[str(userid)] = [str(es.ServerVar("dd_attacker")), str(es.ServerVar("dd_weapon")), headshot]
        try: gamethread.delayedname(float(delay), "death_%s" % userid, kill, userid)
        except: pass

def kill(userid):
    if str(userid) in players: es.sexec(userid, "kill")

def player_death_hooked():
    userid = es.ServerVar("dd_userid", 0)
    es.server.cmd("est_geteventinfo dd_userid userid")
    userid = str(userid)
    if userid in players and not players[userid][1] == "":
        for x in range(len(players[userid])): es.server.cmd("est_seteventinfo %s %s" % (properties[x], str(players[userid][x])))
        del players[userid]

def player_spawn(event_var):
    if event_var["userid"] in players:
        gamethread.cancelDelayed("death_%s" % event_var["userid"])
        del players[event_var["userid"]]